package org.codehaus.xfire.message;

import java.util.Calendar;
import java.util.Date;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamWriter;

/**
 * Writes messages to an output stream.
 * 
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 */
public interface MessageWriter
{
    void writeValue( Object value );
    
    void writeValue( Object value, String ns, String attr );

    void writeValueAsCalendar( Calendar calendar );
    
    void writeValueAsCalendar( Calendar calendar, String ns, String attr );

    void writeValueAsDate( Date date );
    
    void writeValueAsDate( Date date, String ns, String attr );
    
    void writeValueAsDateTime( Date date );
    
    void writeValueAsDateTime( Date date, String ns, String attr );
    //void writeValueAsTime( Date date );

    void writeValueAsInt( Integer i );

    void writeValueAsInt( Integer i, String ns, String attr );

    void writeValueAsDouble(Double double1);

    void writeValueAsDouble(Double double1, String ns, String attr);

    void writeValueAsLong(Long l);

    void writeValueAsLong(Long l, String ns, String attr);

    void writeValueAsFloat(Float f);

    void writeValueAsFloat(Float f, String ns, String attr);

    MessageWriter getChildWriter(String name);

    MessageWriter getChildWriter(String name, String namespace);
    
    MessageWriter getChildWriter(QName qname);
    
    String getNamespace();
    
    void setNamespace( String namespace );

	/**
	 * @param b
	 */
	void writeValueAsBoolean(boolean b);
    
    /**
     * Tells the MessageWriter that writing operations are completed so 
     * it can write the end element.
     */
    void close();
    
    XMLStreamWriter getXMLStreamWriter();
}
