package org.codehaus.xfire.service.object;

import java.lang.reflect.Method;
import java.util.Collection;
import java.util.Hashtable;
import javax.xml.namespace.QName;

/**
 * An operation that be performed on a service.
 * 
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 * @since Feb 20, 2004
 */
public class Operation
{
    private Hashtable inParams;

    private Hashtable outParams;
        
    private Method method;

    public Operation( final Method method )
    {
        inParams = new Hashtable();
        outParams = new Hashtable();

        this.method = method;
    }

    public Class getInParameterClass( final String paramName )
    {
        return (Class) inParams.get( paramName );
    }

    public void addInParameter( final Parameter p )
    {
        inParams.put( p.getName(), p );
    }
    
    public Parameter getInParameter( final QName q )
    {
        return (Parameter) inParams.get(q);
    }
    
    public Collection getInParameters()
    {
        return inParams.values();
    }

    public Class getOutParameterClass( final String paramName )
    {
        return (Class) outParams.get( paramName );
    }

    public void addOutParameter( final Parameter p )
    {
        outParams.put( p.getName(), p );
    }
    
    public Parameter getOutParameter( final QName q )
    {
        return (Parameter) outParams.get(q);
    }
    
    public Collection getOutParameters()
    {
        return outParams.values();
    }
    
    public Method getMethod()
    {
        return method;
    }

    public String getName()
    {
        return method.getName();
    }
}
