package org.codehaus.xfire.service.object;

import javax.xml.namespace.QName;

import org.codehaus.xfire.MessageContext;
import org.codehaus.xfire.fault.XFireFault;
import org.codehaus.xfire.message.MessageReader;
import org.codehaus.xfire.message.MessageWriter;
import org.codehaus.xfire.type.Type;

/**
 * A parameter for an operation.
 * 
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 * @since Nov 16, 2004
 */
public class Parameter
{
    private QName name;
    private Class typeClass;
    
    public Parameter()
    {
    }
    
    public Parameter(QName name, Class typeClass)
    {
        this.name = name;
        this.typeClass = typeClass;
    }
    
    /**
     * @return Returns the name.
     */
    public QName getName()
    {
        return name;
    }
    
    /**
     * @param name The name to set.
     */
    public void setName(QName name)
    {
        this.name = name;
    }

    public Class getTypeClass()
    {
        return typeClass;
    }
    
    public void setTypeClass(Class typeClass)
    {
        this.typeClass = typeClass;
    }
    
    public Object read(MessageReader reader, MessageContext context) 
        throws XFireFault
    {
        Type type = ((ObjectService)context.getService()).getTypeMapping().getType(getTypeClass());
        
        return type.readObject(reader, context);
    }
    
    public void write(Object value, MessageWriter writer, MessageContext context) 
        throws XFireFault
    {
        Type type = ((ObjectService)context.getService()).getTypeMapping().getType(getTypeClass());

        MessageWriter childWriter = writer.getChildWriter(getName());

        type.writeObject(value, childWriter, context);

        writer.close();
    }
}
