package org.codehaus.xfire.message;

import java.util.Date;

import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamReader;

import org.codehaus.xfire.message.LiteralReader;
import org.codehaus.xfire.message.MessageReader;
import org.codehaus.xfire.test.AbstractXFireTest;

/**
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 * @since Nov 4, 2004
 */
public class ReaderTest
    extends AbstractXFireTest
{
    public void testLiteralReader()
        throws Exception
    {
        XMLInputFactory factory = XMLInputFactory.newInstance();
        XMLStreamReader reader = factory.createXMLStreamReader( 
                getResourceAsStream("/org/codehaus/xfire/message/document/bean11.xml"));
        
        while ( reader.getEventType() != XMLStreamReader.START_ELEMENT )
            reader.next();
        
        LiteralReader lr = new LiteralReader(reader);
        assertTrue( lr.getLocalName().equals("Envelope") );
        
        // make sure we can repeat this
        assertTrue( lr.hasMoreChildReaders() );
        assertTrue( lr.hasMoreChildReaders() );
        assertTrue( lr.hasMoreChildReaders() );
        
        MessageReader header = lr.getNextChildReader();
        assertEquals( "Header", header.getLocalName() );
        assertFalse( header.hasMoreChildReaders() );
        
        MessageReader body = lr.getNextChildReader();
        assertEquals( "Body", body.getLocalName() );
        assertFalse( body.hasMoreChildReaders() );
        
        // currently there are still some hierarchy problems
    }
    
    public void testDates() throws Exception
    {
        XMLInputFactory factory = XMLInputFactory.newInstance();
        XMLStreamReader xr = factory.createXMLStreamReader( 
                getResourceAsStream( "/org/codehaus/xfire/message/dates.xml" ) );
        
        while ( xr.getEventType() != XMLStreamReader.START_ELEMENT )
            xr.next();
        
        MessageReader reader = new LiteralReader(xr);
        
        Date date0 = reader.getNextChildReader().getValueAsDate();
        assertNotNull(date0);
        Date dateTime0 = reader.getNextChildReader().getValueAsDateTime();
        assertNotNull(dateTime0);
        Date dateTime1 = reader.getNextChildReader().getValueAsDateTime();
        assertNotNull(dateTime1);
        Date dateTime2 = reader.getNextChildReader().getValueAsDateTime();
        assertNotNull(dateTime2);
        
        Date dateTime3 = reader.getNextChildReader().getValueAsDateTime();
        assertNotNull(dateTime3);
        Date dateTime4 = reader.getNextChildReader().getValueAsDateTime();
        assertNotNull(dateTime4);
        assertTrue ( dateTime3.before( dateTime4 ) );
        
        Date dateTime5 = reader.getNextChildReader().getValueAsDateTime();
        assertNotNull(dateTime5);
        Date dateTime6 = reader.getNextChildReader().getValueAsDateTime();
        assertNotNull(dateTime6);
        assertTrue ( dateTime5.before( dateTime6 ) );
                        
        //Date time0 = reader.getReader("time0").getValueAsTime();
    }
}
