package org.codehaus.xfire.message.wrapped;

import org.codehaus.xfire.services.VoidService;
import org.codehaus.xfire.soap.SoapConstants;
import org.codehaus.xfire.test.AbstractXFireTypeTest;
import org.codehaus.xfire.wsdl.WSDLWriter;
import org.dom4j.Document;

/**
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 * @since Dec 20, 2004
 */
public class VoidTest
    extends AbstractXFireTypeTest
{
    public void setUp() throws Exception
    {
        super.setUp();
        
        getServiceBuilder().create(VoidService.class);
    }
    
    public void testBeanService() throws Exception
    {
        Document response = 
            invokeService("VoidService", 
                          "/org/codehaus/xfire/message/wrapped/voidRequest.xml");

        addNamespace( "sb", "http://services.xfire.codehaus.org" );
        assertValid( "/s:Envelope/s:Body/sb:doNothingResponse", response );
    }
    
    public void testBeanServiceWSDL() throws Exception
    {
        Document doc = getWSDLDocument("VoidService");

        addNamespace( "wsdl", WSDLWriter.WSDL11_NS );
        addNamespace( "wsdlsoap", WSDLWriter.WSDL11_SOAP_NS );
        addNamespace( "xsd", SoapConstants.XSD );
        
        // TODO: Test that the messsages are correct
    }
}
