package org.codehaus.xfire.transport.http;

import org.codehaus.xfire.service.object.ObjectServiceBuilder;
import org.codehaus.xfire.service.object.ServiceBuilder;
import org.codehaus.xfire.services.BeanService;
import org.codehaus.xfire.test.AbstractServletTest;
import org.codehaus.xfire.test.TestHttpTransport;
import org.codehaus.xfire.transport.TransportManager;
import org.codehaus.xfire.type.DefaultTypeMappingRegistry;
import org.codehaus.xfire.type.TypeMapping;
import org.codehaus.xfire.type.TypeMappingRegistry;
import org.dom4j.Document;

import com.meterware.httpunit.PostMethodWebRequest;
import com.meterware.httpunit.WebRequest;
import com.meterware.httpunit.WebResponse;

/**
 * XFireServletTest
 * 
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 */
public class XFireServletTest
    extends AbstractServletTest
{
    private  DefaultTypeMappingRegistry registry;
    private ServiceBuilder builder;

    public void setUp() throws Exception
    {
        super.setUp();
        
        registry = new DefaultTypeMappingRegistry();
        
        TypeMapping tm = registry.createDefaultMappings();
        registry.registerDefault(tm);        
        
        TransportManager trans = getXFire().getTransportManager();
        trans.register( new TestHttpTransport() );


        builder = new ObjectServiceBuilder(getXFire(), registry);
        builder.create(BeanService.class);
    }

    public TypeMappingRegistry getRegistry()
    {
        return registry;
    }
    
    public ServiceBuilder getBuilder()
    {
        return builder;
    }
    
    public void testServlet() throws Exception
    {
        WebResponse response = newClient().getResponse( "http://localhost/services/BeanService?wsdl" );
        
        Document resDoc = readDocument(response.getText());
        printNode(resDoc);
        
        WebRequest req = new PostMethodWebRequest( "http://localhost/services/BeanService",
                getClass().getResourceAsStream("/org/codehaus/xfire/message/wrapped/bean11.xml"),
                "text/xml" );

        response = newClient().getResponse(req);
        
        resDoc = readDocument(response.getText());
        printNode(resDoc);
    }
}
