package org.codehaus.xfire.wsdl11;

import javax.xml.namespace.QName;

import org.codehaus.xfire.service.object.ObjectService;
import org.codehaus.xfire.service.object.Operation;
import org.codehaus.xfire.services.Echo;
import org.codehaus.xfire.test.AbstractXFireTypeTest;
import org.codehaus.xfire.type.AutoTypeMapping;
import org.codehaus.xfire.type.TypeMapping;
import org.codehaus.xfire.type.basic.StringType;
import org.dom4j.Document;

/**
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 */
public class WSDLVisitorTest
    extends AbstractXFireTypeTest
{
    public void testVisitor()
        throws Exception
    {
        TypeMapping tm = new AutoTypeMapping();
        tm.register(String.class, new QName("urn:Echo", "echoRequest"), new StringType());
        tm.register(String.class, new QName("urn:Echo", "echoResponse"), new StringType());
        
        ObjectService service = 
            (ObjectService) getServiceBuilder()
                .create(Echo.class, tm, getTestFile("src/test/org/codehaus/xfire/wsdl11/Echo.wsdl").toURL());
        
        assertEquals(1, service.getOperations().size());
        
        Operation o = service.getOperation("echo");
        assertNotNull(o);
        
        Document response = invokeService("Echo", "/org/codehaus/xfire/wsdl11/echo11.xml");
        
        addNamespace("e", "urn:Echo");
        assertValid("//e:echoResponse[text()='Yo Yo']", response);
    }
}
